-- generic 74X244 type tri-state buffer
library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;

entity xbuf is
     generic ( tDE :time := 5 ns; tDZ : time := 5 ns);
     port (
        input : in STD_LOGIC;
        output : out STD_LOGIC;
        not_en: in STD_LOGIC
    );
end xbuf;

library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;

architecture xbuf_arch of xbuf is
begin

proc_en: process (not_en,input)
begin
if (not_en='0') then
  output <= input after tDE;
else
  output <= 'Z' after tDZ;
end if;
end process proc_en;

end xbuf_arch;

library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;


entity xbufn is
generic ( size :integer := 32; tDE :time := 5 ns; tDZ : time := 5 ns);
    port (
        input : in STD_LOGIC_VECTOR (size-1 downto 0);
        output : out STD_LOGIC_VECTOR (size-1 downto 0);
        not_en: in STD_LOGIC
    );
end xbufn;

library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;

architecture xbufn_arch of xbufn is
-- Component instantiated by Turbo autoplace on 10/26/95 at 11:06:12
COMPONENT xbuf
     generic ( tDE :time := 5 ns; tDZ : time := 5 ns);
    port (
        input : in STD_LOGIC;
        output : out STD_LOGIC;
        not_en: in STD_LOGIC
    );
END COMPONENT;
begin

c_call: FOR i IN 0 TO size-1 GENERATE
          bits: xbuf
          generic map ( tDE => tDE, tDZ=> tDZ)
          port map (input => input(i), output => output(i), not_en => not_en);
        END GENERATE;    
end xbufN_arch;
